function x = gauss(N,a)

% Il faut que deux conditions soient verifiees :
% - tilde ga doit etre une bonne approximation de ga : en faisant
%   explicitement le calcul, on voit que cela va etre le cas si M
%   est au moins de l'ordre de 1000.
% - si on note [-K,K] l'intervalle sur lequel tilde ga prend des
%   valeurs non negligeables, il faut avoir M > N+2K, pour que la
%   restriction a [0,...,N-1] de la convolution circulaire soit a
%   peu pres egale aux valeurs qu'on aurait obtenues par une
%   convolution non-circulaire. K vaut a peu pres 100 donc il faut
%   M au moins egal a N+200.
M = max(1000,N+200) ;

z = randn(1,M) ;

ga_tilde_f = [0:M-1] ;
ga_tilde_f = (ga_tilde_f<=M*a/(2*pi)) + ...
    (ga_tilde_f>=M*(1-a/(2*pi))) ;

x = ifft(fft(z).*ga_tilde_f) ;
x = real(x(1:N)) ;