clear all ;

N = 1000 ;
a = 0.1 ;

% affichage d'une realisation de Xa
figure (1) ; plot(gauss(N,a)) ;

% 4
% La transformee de fourier de h doit valoir 1/(1+sigma^2) sur
% [-a;a] et 0 ailleurs. On doit donc avoir :
%       h(k) = a sinc(ak) / pi(1+sigma^2)
N = 1000 ; L = 100 ;
sigma = 0.1 ;

% 5.a)
xa = gauss(N+2*L,a) ;
y = sigma * randn(1,N+2*L) ;
d = xa+y ;

% 5.b)
% Par un raisonnement similaire a la question 2., on peut
% approximer D star h par la partie centrale d'une convolution
% circulaire.
M = N+2*L ;
h_f = [0:M-1] ;
h_f = ((h_f<=M*a/(2*pi)) + (h_f>=M*(1-a/(2*pi)))) / (1+sigma^2) ;
d_conv_h = real(ifft(h_f .* fft(d))) ;
d_conv_h = d_conv_h(L+1:L+N) ;

% 5.c)
figure (2) ; clf ; hold on ;
plot(d(L+1:L+N),'c') ;
plot(xa(L+1:L+N)) ;
plot(d_conv_h,'r') ;

% 6
N = 1000 ; p = 0.995 ;
figure (3) ;
plot(cpm(N,p)) ;
axis([1,N,-1.1,1.1]) ; % changement d'echelle pour que l'affichage soit
                       % plus agreable

% La transformee de Fourier de R_Z vaut :
%       (1-(2p-1)^2) / (1-2.(2p-1)cos(omega)+(2p-1)^2)
% On en deduit la valeur de la transformee de Fourier de h.
sigma = 0.1 ;
L = 100 ;
M = N + 2*L ; ;
omega = 2*pi*[0:M-1]/M ;
h_f = 1 ./ (1 + sigma^2 .* (1+(2*p-1)^2-2*(2*p-1)*cos(omega)) ...
            / (1-(2*p-1)^2)) ;

% realisation de Z
z = cpm(N+2*L,p) ;
% realisation de Y
y = sigma * randn(1,N+2*L) ;
% realisation de D
d = z + y ;

% convolution circulaire
d_conv_h = ifft(fft(d).*h_f) ;
% les indices L+1 à N+L valent a peu pres D\star h[0],...,D\star h[N-1]
d_conv_h = real(d_conv_h(L+1:N+L)) ;

% affichage
figure (4) ; clf ; hold on ;
plot(d(L+1:N+L),'c') ;
plot(z(L+1:N+L)) ;
plot(d_conv_h,'r') ;
